
/*
	La version toujours plus dveloppe de l'applet "maison"
	La classe qui gere les mouvements des figures...

	(C) J. Ferber - Octobre 2000
*/

package maison;

import java.awt.*;
import java.applet.Applet;
import java.awt.event.*;
import java.util.Vector;
import java.io.*;

/** Racine des figures qui sont dessines dans un rectangle.
	En fait la plupart des figures a part les lignes...
*/

abstract class MovingFigure extends Figure {

	int h, l;

	int dx=3;
	int dy=3;

	
	java.awt.Rectangle bounds;

	void setSpeed(int _dx, int _dy){dx = _dx; dy = _dy;}
  	

	public void activate(DrawingPane env){
		bounds=env.getBounds();
		move();
	}

	void move(){
		x=x+dx;
		y=y+dy;
		collisionDetection();
	}

  void collisionDetection(){
	if (x<0){
		x=0;
		dx=-dx;
	}
	else if (x+l > bounds.width){
		x=bounds.width-l;
		dx = -dx;
	}
	else if (y < 0){
		y = 0;
		dy = -dy;
	}
	else if (y+h > bounds.height){
		y=bounds.height-h;
		dy = -dy;
	}
  }

  	public void saveBody(PrintWriter fos){
		super.saveBody(fos);
		fos.print(", "+h+", "+l+", "+dx+", "+dy);
	}

	public void parse(StreamTokenizer st, DrawingPane d) {
		super.parse(st,d);
    	try {
       		st.nextToken(); h = (int) st.nval;
    		st.nextToken(); l = (int) st.nval;
       		st.nextToken(); dx = (int) st.nval;
    		st.nextToken(); dy = (int) st.nval;
       }
       catch (IOException e) {
            	System.err.println("parse: " + e);
       }
    }
 

}